AC_PREREQ(2.59)
AC_INIT([<$TEST_SUITE_NAME$>], [<$TEST_SUITE_VERSION$>], [<$TEST_SUITE_BUGREPORT$>])
AC_CONFIG_AUX_DIR([build-aux])
AC_CONFIG_MACRO_DIR([m4])

AM_INIT_AUTOMAKE([1.9 -Wall -Werror dist-bzip2 foreign tar-ustar])

# Default compiler flags. 
if test "x${CFLAGS}" = "x"; then
    CFLAGS="-g -O2 -DNDEBUG"
fi 

AC_PROG_CC
AC_PROG_LIBTOOL

# Check for appropriate version of Glib and define Glib_CFLAGS and Glib_LIBS 
# if successful.
# As Glib Testing Framework appeared in version 2.16, at least this version 
# is required.
PKG_CHECK_MODULES(Glib, glib-2.0 >= 2.16)

# Provide common options and input files for the compiler and linker
COMMON_COMPILER_FLAGS="<$COMMON_COMPILER_FLAGS$>"
COMMON_LINKER_FLAGS="<$COMMON_LINKER_FLAGS$>"
COMMON_LIBS="<$COMMON_LIBS$>"
AC_SUBST([COMMON_COMPILER_FLAGS])
AC_SUBST([COMMON_LINKER_FLAGS])
AC_SUBST([COMMON_LIBS])

# Determine the absolute paths to the top suite and build directories
ABS_TOP_SUITE_DIR=$(cd `dirname $0` && pwd)
ABS_TOP_BUILD_DIR=$(pwd)
AC_SUBST([ABS_TOP_SUITE_DIR])
AC_SUBST([ABS_TOP_BUILD_DIR])

# The list of files to generate
AC_CONFIG_FILES([ 
<$if concat(TEST_MODULE)$><$makefile_item: join(\n)$><$endif$>
    t2c_api/<$TARGET$>/Makefile 
    testdata/Makefile
    Makefile
])
AC_OUTPUT   
