###########################################################################
# Makefile for <$T2C_FILE_NAME$>,
# test suite:  <$SUITE_NAME$>, 
# target:      <$TARGET$>
#
# This file is created by T2C system.
###########################################################################

# Name of the test executable (the same for all the tests)
TEST_NAME = test_module

# Name of the test source file
TEST_SRC_NAME = <$T2C_FILE_NAME$>

# Common parameters
SUITE_ROOT_DIR = $(top_srcdir)
SUITE_INC_DIR  = "$(SUITE_ROOT_DIR)/include"

T2C_API_DIR    = "$(top_builddir)/t2c_api/<$TARGET$>"
T2C_API_INC    = "$(top_srcdir)/t2c_api/<$TARGET$>"
T2C_API_LIB    = t2c_api

# Specify the test program we want to build
# Do not define $(TESTS) here, rather list the tests in the Makefile 
# one level higher
noinst_PROGRAMS = $(TEST_NAME)
check_PROGRAMS = $(TEST_NAME)

BASE_PACKAGE_SRC_DIR = <$BASE_PACKAGE_SRC_DIR$>
BASE_PACKAGE_INC_DIR = <$BASE_PACKAGE_INC_DIR$>

test_module_SOURCES = <$ADD_SOURCES$> <$ADD_HEADERS$> \
	<$T2C_FILE_NAME$>.<$if TEST_SOURCE_EXT$><$TEST_SOURCE_EXT$><$else$>c<$endif$>

test_module_CPPFLAGS = -std=c99 -U__STRICT_ANSI__ \
	-DTOP_SUITE_DIR=\""@ABS_TOP_SUITE_DIR@"\" \
	-DTOP_BUILD_DIR=\""@ABS_TOP_BUILD_DIR@"\"

test_module_CFLAGS = <$ADD_COMPILER_FLAGS$> @COMMON_COMPILER_FLAGS@ @Glib_CFLAGS@ \
	<$if BASE_PACKAGE_INC_DIR$>-I$(BASE_PACKAGE_INC_DIR)<$endif$> -I$(SUITE_INC_DIR) \
	-I$(T2C_API_INC)
	
test_module_LDFLAGS = <$ADD_LINKER_FLAGS$> @COMMON_LINKER_FLAGS@

test_module_LDADD = <$ADD_LIBS$>  @COMMON_LIBS@ \
	-L$(T2C_API_DIR) -l$(T2C_API_LIB) \
	@Glib_LIBS@

test: $(TEST_NAME)
	gtester -o=$(TEST_SRC_NAME).xml -k ./$(TEST_NAME)

test-report-html: test
	gtester-report $(TEST_SRC_NAME).xml >$(TEST_SRC_NAME).html

test-report-display: test-report-html
	gnome-open $(TEST_SRC_NAME).html

