###########################################################################
# Makefile for <$T2C_FILE_NAME$>,
# test suite:  <$SUITE_NAME$>, 
# target:      <$TARGET$>
#
# This file is created by T2C system.
###########################################################################

# Name and extension of the test source file
TEST_NAME = <$T2C_FILE_NAME$>
TEST_EXT  = <$if TEST_SOURCE_EXT$><$TEST_SOURCE_EXT$><$else$>c<$endif$>

# Common parameters
# TET_-prefixed parameters require $TET_ROOT environment variable to be defined

# Determine absolute suite root path here (this file might have been generated
# on another machine).
SUITE_ROOT_DIR := $(shell (cd "../.." && pwd))
SUITE_INC_DIR  = "$(SUITE_ROOT_DIR)/include"

T2C_API_DIR    = $(SUITE_ROOT_DIR)/../t2c_api/<$TARGET$>
T2C_API_INC    = "$(T2C_API_DIR)/include"
T2C_API_OBJS   = "$(T2C_API_DIR)/lib/t2c_api.a"
T2C_API_OBJS_D = "$(T2C_API_DIR)/lib/t2c_api_d.a"

TET_API_INC    = "$(TET_ROOT)/inc/tet3"
TET_API_OBJS   = "$(TET_ROOT)/lib/tet3/tcm.o" "$(TET_ROOT)/lib/tet3/libapi.a"
TET_API_OBJS_D = $(TET_API_OBJS)

# Useful commands
TEST_ENV_TET_ROOT := \
	if test "x$$TET_ROOT" = "x"; then \
		echo "Environment variable TET_ROOT is not defined or is empty"; \
		exit 1; \
	fi

# The following options (coming from <$SUITE_NAME$>.cfg file) may differ 
# for different test suites in the package

# If you want to specify the compiler in the <$SUITE_NAME$>.cfg file,
# set $(CC) here appropriately. 
#
# CC = ...

COMMON_CFLAGS = <$COMPILER_FLAGS$> \
	-std=c99 -D"_POSIX_C_SOURCE=200112L" \
	-I$(TET_API_INC) -I$(T2C_API_INC) -I$(SUITE_INC_DIR)

COMMON_LFLAGS = <$LINKER_FLAGS$>

# Not sure if the following will be of any use now...
# CC_SPECIAL_FLAGS := $(shell (cat $(SUITE_ROOT_DIR)/../cc_special_flags) 2>/dev/null)

.PHONY: all debug clean
all: $(TEST_NAME)

$(TEST_NAME): $(TEST_NAME).$(TEST_EXT)
		@$(TEST_ENV_TET_ROOT)
		$(CC) -O2 -DNDEBUG $(COMMON_CFLAGS) -o $(TEST_NAME) $< $(COMMON_LFLAGS) $(T2C_API_OBJS) $(TET_API_OBJS)
		@chmod a+x $(TEST_NAME)

debug: $(TEST_NAME).$(TEST_EXT)
		@$(TEST_ENV_TET_ROOT)
		$(CC) -g $(COMMON_CFLAGS) -o $(TEST_NAME) $< $(COMMON_LFLAGS) $(T2C_API_OBJS_D) $(TET_API_OBJS_D)
		@chmod a+x $(TEST_NAME)

clean:
		rm -f $(TEST_NAME).o $(TEST_NAME) tet_*
